## boinc 8.2.5+dfsg

=== lib/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
project(boinc-libs)

message(WARNING "This build is under development and may not work as expected")

find_package(OpenSSL REQUIRED)

set(BOINC_DIR ${PROJECT_SOURCE_DIR}/..)

set(LIBBOINC_HEADERS_WIN
    ${BOINC_DIR}/lib/boinc_win.h
    ${BOINC_DIR}/lib/diagnostics_win.h
    ${BOINC_DIR}/lib/idlemon.h
    ${BOINC_DIR}/lib/stackwalker_imports.h
    ${BOINC_DIR}/lib/stackwalker_win.h
)

set(LIBBOINC_HEADERS_UNIX
    ${BOINC_DIR}/lib/synch.h
    ${BOINC_DIR}/lib/unix_util.h
)

set(LIBBOINC_HEADERS_APPLE
    ${BOINC_DIR}/lib/synch.h
    ${BOINC_DIR}/lib/mac/dyld_gdb.h
    ${BOINC_DIR}/lib/mac/mac_backtrace.h
    ${BOINC_DIR}/lib/mac/mac_spawn.h
    ${BOINC_DIR}/lib/mac/QBacktrace.h
    ${BOINC_DIR}/lib/mac/QCrashReport.h
    ${BOINC_DIR}/lib/mac/QMachOImage.h
    ${BOINC_DIR}/lib/mac/QMachOImageList.h
    ${BOINC_DIR}/lib/mac/QSymbols.h
    ${BOINC_DIR}/lib/mac/QTaskMemory.h
    ${BOINC_DIR}/lib/mac/mac_branding.h
)

set(LIBBOINC_HEADERS_GENERIC
    ${BOINC_DIR}/lib/app_ipc.h
    ${BOINC_DIR}/lib/base64.h
    ${BOINC_DIR}/lib/boinc_stdio.h
    ${BOINC_DIR}/lib/cal_boinc.h
    ${BOINC_DIR}/lib/cc_config.h
    ${BOINC_DIR}/lib/cert_sig.h
    ${BOINC_DIR}/lib/cl_boinc.h
    ${BOINC_DIR}/lib/common_defs.h
    ${BOINC_DIR}/lib/coproc.h
    ${BOINC_DIR}/lib/crypt.h
    ${BOINC_DIR}/lib/diagnostics.h
    ${BOINC_DIR}/lib/error_numbers.h
    ${BOINC_DIR}/lib/filesys.h
    ${BOINC_DIR}/lib/hostinfo.h
    ${BOINC_DIR}/lib/keyword.h
    ${BOINC_DIR}/lib/md5.h
    ${BOINC_DIR}/lib/md5_file.h
    ${BOINC_DIR}/lib/mem_usage.h
    ${BOINC_DIR}/lib/mfile.h
    ${BOINC_DIR}/lib/miofile.h
    ${BOINC_DIR}/lib/network.h
    ${BOINC_DIR}/lib/notice.h
    ${BOINC_DIR}/lib/opencl_boinc.h
    ${BOINC_DIR}/lib/parse.h
    ${BOINC_DIR}/lib/prefs.h
    ${BOINC_DIR}/lib/proc_control.h
    ${BOINC_DIR}/lib/procinfo.h
    ${BOINC_DIR}/lib/project_init.h
    ${BOINC_DIR}/lib/proxy_info.h
    ${BOINC_DIR}/lib/std_fixes.h
    ${BOINC_DIR}/lib/str_replace.h
    ${BOINC_DIR}/lib/str_util.h
    ${BOINC_DIR}/lib/url.h
    ${BOINC_DIR}/lib/util.h
    ${BOINC_DIR}/lib/win_util.h
    ${BOINC_DIR}/lib/wslinfo.h
)

set(LIBBOINC_SOURCES_WIN
    ${BOINC_DIR}/lib/boinc_win.cpp
    ${BOINC_DIR}/lib/diagnostics_win.cpp
    ${BOINC_DIR}/lib/idlemon_win.cpp
    ${BOINC_DIR}/lib/procinfo_win.cpp
    ${BOINC_DIR}/lib/stackwalker_win.cpp
    ${BOINC_DIR}/lib/win_util.cpp
)

set(LIBBOINC_SOURCES_UNIX
    ${BOINC_DIR}/lib/procinfo_unix.cpp
    ${BOINC_DIR}/lib/synch.cpp
    ${BOINC_DIR}/lib/unix_util.cpp
)

set(LIBBOINC_SOURCES_APPLE
    ${BOINC_DIR}/lib/procinfo_mac.cpp
    ${BOINC_DIR}/lib/synch.cpp
    ${BOINC_DIR}/lib/mac/mac_backtrace.cpp
    ${BOINC_DIR}/lib/mac/mac_spawn.cpp
    ${BOINC_DIR}/lib/mac/QBacktrace.c
    ${BOINC_DIR}/lib/mac/QCrashReport.c
    ${BOINC_DIR}/lib/mac/QMachOImage.c
    ${BOINC_DIR}/lib/mac/QMachOImageList.c
    ${BOINC_DIR}/lib/mac/QSymbols.c
    ${BOINC_DIR}/lib/mac/QTaskMemory.c
    ${BOINC_DIR}/lib/mac/mac_branding.cpp
)

set(LIBBOINC_SOURCES_GENERIC
    ${BOINC_DIR}/lib/app_ipc.cpp
    ${BOINC_DIR}/lib/base64.cpp
    ${BOINC_DIR}/lib/cc_config.cpp
    ${BOINC_DIR}/lib/cert_sig.cpp
    ${BOINC_DIR}/lib/coproc.cpp
    ${BOINC_DIR}/lib/crypt.cpp
    ${BOINC_DIR}/lib/diagnostics.cpp
    ${BOINC_DIR}/lib/filesys.cpp
    ${BOINC_DIR}/lib/hostinfo.cpp
    ${BOINC_DIR}/lib/keyword.cpp
    ${BOINC_DIR}/lib/md5.cpp
    ${BOINC_DIR}/lib/md5_file.cpp
    ${BOINC_DIR}/lib/mem_usage.cpp
    ${BOINC_DIR}/lib/mfile.cpp
    ${BOINC_DIR}/lib/miofile.cpp
    ${BOINC_DIR}/lib/network.cpp
    ${BOINC_DIR}/lib/notice.cpp
    ${BOINC_DIR}/lib/opencl_boinc.cpp
    ${BOINC_DIR}/lib/parse.cpp
    ${BOINC_DIR}/lib/prefs.cpp
    ${BOINC_DIR}/lib/proc_control.cpp
    ${BOINC_DIR}/lib/procinfo.cpp
    ${BOINC_DIR}/lib/project_init.cpp
    ${BOINC_DIR}/lib/proxy_info.cpp
    ${BOINC_DIR}/lib/shmem.cpp
    ${BOINC_DIR}/lib/str_util.cpp
    ${BOINC_DIR}/lib/url.cpp
    ${BOINC_DIR}/lib/util.cpp
    ${BOINC_DIR}/lib/wslinfo.cpp
)

set(LIBBOINCAPI_HEADERS
    ${BOINC_DIR}/api/boinc_api.h
)

set(LIBBOINCAPI_SOURCES_WIN
    ${BOINC_DIR}/lib/boinc_win.cpp
)

set(LIBBOINCAPI_SOURCES_GENERIC
    ${BOINC_DIR}/api/boinc_api.cpp
)

if(APPLE)
    set(LIBBOINC_HEADERS ${LIBBOINC_HEADERS_GENERIC} ${LIBBOINC_HEADERS_APPLE})
    set(LIBBOINC_SOURCES ${LIBBOINC_SOURCES_GENERIC} ${LIBBOINC_SOURCES_APPLE})

    set(LIBBOINCAPI_SOURCES ${LIBBOINCAPI_SOURCES_GENERIC})
elseif(WIN32)
    set(LIBBOINC_HEADERS ${LIBBOINC_HEADERS_GENERIC} ${LIBBOINC_HEADERS_WIN})
    set(LIBBOINC_SOURCES ${LIBBOINC_SOURCES_GENERIC} ${LIBBOINC_SOURCES_WIN})

    set(LIBBOINCAPI_SOURCES ${LIBBOINCAPI_SOURCES_GENERIC} ${LIBBOINCAPI_SOURCES_WIN})
elseif(UNIX)
    set(LIBBOINC_HEADERS ${LIBBOINC_HEADERS_GENERIC} ${LIBBOINC_HEADERS_UNIX})
    set(LIBBOINC_SOURCES ${LIBBOINC_SOURCES_GENERIC} ${LIBBOINC_SOURCES_UNIX})

    set(LIBBOINCAPI_SOURCES ${LIBBOINCAPI_SOURCES_GENERIC})
endif()

add_library(boinc ${LIBBOINC_SOURCES})
add_library(boincapi ${LIBBOINCAPI_SOURCES})

if(WIN32 OR APPLE)
    set_target_properties(boinc PROPERTIES PREFIX "lib")
    set_target_properties(boinc PROPERTIES IMPORT_PREFIX "lib")

    set_target_properties(boincapi PROPERTIES PREFIX "lib")
    set_target_properties(boincapi PROPERTIES IMPORT_PREFIX "lib")
endif()

# currently this is for MinGW only
set(build_options "")
if(HAVE_STRCASECMP)
    list(APPEND build_options "-DHAVE_STRCASECMP")
endif()

if(APPLE)
    target_include_directories(boinc PUBLIC
                                $<BUILD_INTERFACE:${BOINC_DIR}/lib/mac>
                                $<BUILD_INTERFACE:${BOINC_DIR}/clientgui/mac>
    )

    target_include_directories(boincapi PUBLIC
                                $<BUILD_INTERFACE:${BOINC_DIR}/lib/mac>
                                $<BUILD_INTERFACE:${BOINC_DIR}/clientgui/mac>
    )
elseif(WIN32)
    target_compile_definitions(boinc PUBLIC
                                -D_CRT_SECURE_NO_WARNINGS
                                -DWIN32
                                -D_CONSOLE
                                ${build_options}
    )

    target_compile_definitions(boincapi PUBLIC
                                -D_CRT_SECURE_NO_WARNINGS
                                -DWIN32
                                -D_CONSOLE
                                ${build_options}
    )

    target_include_directories(boinc PUBLIC
                                $<BUILD_INTERFACE:${BOINC_DIR}/win_build>
    )

    target_include_directories(boincapi PUBLIC
                                $<BUILD_INTERFACE:${BOINC_DIR}/win_build>
    )
elseif(UNIX)
    execute_process(COMMAND ./configure --disable-server --disable-client --disable-manager)

    execute_process(COMMAND ${BOINC_DIR}/configure --disable-server --disable-client --disable-manager
        WORKING_DIRECTORY ${BOINC_DIR}
        ECHO_OUTPUT_VARIABLE
        ECHO_ERROR_VARIABLE
    )

    file(COPY ${BOINC_DIR}/config.h DESTINATION ${BOINC_DIR}/config-h)


    target_include_directories(boinc PUBLIC
                                $<BUILD_INTERFACE:${BOINC_DIR}/config-h>
    )

    target_include_directories(boincapi PUBLIC
                                $<BUILD_INTERFACE:${BOINC_DIR}/config-h>
    )
endif()

target_include_directories(boinc PUBLIC
                            $<BUILD_INTERFACE:${BOINC_DIR}>
                            $<BUILD_INTERFACE:${BOINC_DIR}/lib>
                            $<INSTALL_INTERFACE:include>
)

target_include_directories(boincapi PUBLIC
                            $<BUILD_INTERFACE:${BOINC_DIR}>
                            $<BUILD_INTERFACE:${BOINC_DIR}/lib>
                            $<INSTALL_INTERFACE:include>
)

target_link_libraries(boinc PRIVATE
                        OpenSSL::SSL
                        OpenSSL::Crypto
)

target_link_libraries(boincapi PRIVATE
                        boinc
)


include(GNUInstallDirs)

install(TARGETS boinc boincapi EXPORT boinc-config
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

install(FILES ${LIBBOINC_HEADERS} ${LIBBOINCAPI_HEADERS}
    DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/boinc
)

install(EXPORT boinc-config NAMESPACE BOINC::boinc::
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/boinc
)


message(WARNING "This build is under development and may not work as expected")

=== samples/condor/Makefile ===
BOINC_DIR = ../..
BOINC_SOURCE_API_DIR = $(BOINC_DIR)/api
BOINC_SOURCE_LIB_DIR = $(BOINC_DIR)/lib
BOINC_SOURCE_ZIP_DIR = $(BOINC_DIR)/zip

ifdef ANDROID
  BOINC_API_DIR = $(TCINCLUDES)/lib
  BOINC_LIB_DIR = $(TCINCLUDES)/lib
  BOINC_ZIP_DIR = $(TCINCLUDES)/lib

  MAKEFILE_LDFLAGS = -lz
  MAKEFILE_STDLIB  =
else
  BOINC_API_DIR = $(BOINC_SOURCE_API_DIR)
  BOINC_LIB_DIR = $(BOINC_SOURCE_LIB_DIR)
  BOINC_ZIP_DIR = $(BOINC_SOURCE_ZIP_DIR)

  MAKEFILE_LDFLAGS = libstdc++.a -lpthread
  MAKEFILE_STDLIB  = libstdc++.a
endif

CXXFLAGS += \
    -I$(BOINC_DIR) \
    -I$(BOINC_SOURCE_API_DIR) \
    -I$(BOINC_SOURCE_LIB_DIR) \
    -I$(BOINC_SOURCE_ZIP_DIR) \
    -I$(FREETYPE_DIR) \
    -L$(BOINC_API_DIR) \
    -L$(BOINC_LIB_DIR) \
    -L$(BOINC_ZIP_DIR)


ifdef BUILD_APPS_WITH_VCPKG
  BUILD_DIR     = $(BOINC_DIR)/3rdParty/linux
  VCPKG_DIR     ?= $(BUILD_DIR)/vcpkg/installed/x64-linux

  CXXFLAGS += \
    -I$(VCPKG_DIR)/include \
    -L$(VCPKG_DIR)/lib

  CURL_EXTRA_LDFLAGS ?= -lz -ldl
endif

PROGS = boinc_gahp

all: $(PROGS)

libstdc++.a:
	ln -s `$(CXX) $(CXXFLAGS) -print-file-name=libstdc++.a`

clean:
	rm -f $(PROGS) $(addsuffix .exe, $(PROGS)) libstdc++.a *.o

distclean: clean

distclean-recursive: clean

boinc_gahp: boinc_gahp.cpp $(BOINC_SOURCE_LIB_DIR)/remote_submit.h $(BOINC_SOURCE_LIB_DIR)/remote_submit.cpp $(BOINC_DIR)/svn_version.h $(BOINC_DIR)/version.h $(MAKEFILE_STDLIB)
	$(CXX) $(CXXFLAGS) $(CPPFLAGS) $(LDFLAGS) $(MINGW_FLAGS) -g -O3 \
	-o boinc_gahp boinc_gahp.cpp $(BOINC_SOURCE_LIB_DIR)/remote_submit.cpp \
	-lcurl -lssl -lcrypto -lboinc $(CURL_EXTRA_LDFLAGS) $(MAKEFILE_LDFLAGS) $(STDCPPTC)

install: all

=== samples/docker_wrapper/Makefile ===
ifdef ANDROID
  DOCKERWRAPPER_RELEASE_SUFFIX =
else
  ifdef RELEASE_ARCH
    DOCKERWRAPPER_RELEASE_SUFFIX = _$(DOCKERWRAPPER_RELEASE_VERSION)_$(RELEASE_ARCH)-pc-linux-gnu
  else
    DOCKERWRAPPER_RELEASE_SUFFIX = _$(DOCKERWRAPPER_RELEASE_VERSION)_x86_64-pc-linux-gnu
  endif
endif

BOINC_DIR = ../..
BOINC_SOURCE_API_DIR = $(BOINC_DIR)/api
BOINC_SOURCE_LIB_DIR = $(BOINC_DIR)/lib
BOINC_SOURCE_ZIP_DIR = $(BOINC_DIR)/zip

BOINC_API_DIR = $(BOINC_SOURCE_API_DIR)
BOINC_LIB_DIR = $(BOINC_SOURCE_LIB_DIR)
BOINC_ZIP_DIR = $(BOINC_SOURCE_ZIP_DIR)

MAKEFILE_LDFLAGS = -lpthread libstdc++.a
MAKEFILE_STDLIB  = libstdc++.a

CXXFLAGS += -g \
	-Wall -W -Wshadow -Wpointer-arith -Wcast-qual -Wcast-align -Wwrite-strings -fno-common \
    -I$(BOINC_DIR) \
    -I$(BOINC_SOURCE_API_DIR) \
    -I$(BOINC_SOURCE_LIB_DIR) \
    -I$(BOINC_SOURCE_ZIP_DIR) \
    -L$(BOINC_API_DIR) \
    -L$(BOINC_LIB_DIR) \
    -L.

ifdef BUILD_APPS_WITH_VCPKG
  BUILD_DIR     = $(BOINC_DIR)/3rdParty/linux
  VCPKG_DIR     ?= $(BUILD_DIR)/vcpkg/installed/x64-linux

  CXXFLAGS += \
    -I$(VCPKG_DIR)/include \
    -L$(VCPKG_DIR)/lib
endif

ifdef BUILD_WITH_MINGW
  MAKEFILE_LDFLAGS += \
    -lws2_32
endif

PROGS = docker_wrapper$(DOCKERWRAPPER_RELEASE_SUFFIX)
all: $(PROGS)

libstdc++.a:
	ln -s `$(CXX) $(CXXFLAGS) -print-file-name=libstdc++.a`

clean: distclean

distclean:
	/bin/rm -f $(PROGS) $(addsuffix .exe, $(PROGS)) *.o libstdc++.a

install: all

docker_wrapper$(DOCKERWRAPPER_RELEASE_SUFFIX): docker_wrapper.o $(MAKEFILE_STDLIB) $(BOINC_API_DIR)/libboinc_api.a $(BOINC_LIB_DIR)/libboinc.a
	$(CXX) $(CXXFLAGS) $(CPPFLAGS) $(LDFLAGS) -o docker_wrapper$(DOCKERWRAPPER_RELEASE_SUFFIX) docker_wrapper.o \
	-lboinc_api -lboinc $(MAKEFILE_LDFLAGS) \
	$(STDCPPTC)

=== samples/example_app/Makefile ===
# This should work on Linux.  Modify as needed for other platforms.

BOINC_DIR = ../..
BOINC_SOURCE_API_DIR = $(BOINC_DIR)/api
BOINC_SOURCE_LIB_DIR = $(BOINC_DIR)/lib
BOINC_SOURCE_ZIP_DIR = $(BOINC_DIR)/zip
FREETYPE_DIR = /usr/include/freetype2

ifdef ANDROID
  BOINC_API_DIR = $(TCINCLUDES)/lib
  BOINC_LIB_DIR = $(TCINCLUDES)/lib
  BOINC_ZIP_DIR = $(TCINCLUDES)/lib

  MAKEFILE_LDFLAGS =
  MAKEFILE_STDLIB  =
else
  BOINC_API_DIR = $(BOINC_SOURCE_API_DIR)
  BOINC_LIB_DIR = $(BOINC_SOURCE_LIB_DIR)
  BOINC_ZIP_DIR = $(BOINC_SOURCE_ZIP_DIR)

  MAKEFILE_LDFLAGS = -lpthread libstdc++.a
  MAKEFILE_STDLIB  = libstdc++.a
endif

CXXFLAGS += -g \
	-Wall -W -Wshadow -Wpointer-arith -Wcast-qual -Wcast-align -Wwrite-strings -fno-common \
    -DAPP_GRAPHICS \
    -I$(BOINC_DIR) \
    -I$(BOINC_SOURCE_API_DIR) \
    -I$(BOINC_SOURCE_LIB_DIR) \
    -I$(BOINC_SOURCE_ZIP_DIR) \
    -I$(FREETYPE_DIR) \
    -L$(BOINC_API_DIR) \
    -L$(BOINC_LIB_DIR) \
    -L/usr/X11R6/lib \
    -L.

# to get the graphics app to compile you may need to install some packages
# e.g. ftgl-devel.x86_64
#
# You may have to change the paths for your system.

LIBGLUT = -lglut
LIBGLU = -lGLU
LIBGL= -lGL
LIBUI = -lX11 -lXmu
LIBFTGL = -lftgl
LIBJPEG = -ljpeg

ifdef BUILD_APPS_WITH_VCPKG
  BUILD_DIR     = $(BOINC_DIR)/3rdParty/linux
  VCPKG_DIR     ?= $(BUILD_DIR)/vcpkg/installed/x64-linux

  CXXFLAGS += \
    -I$(VCPKG_DIR)/include \
    -L$(VCPKG_DIR)/lib

  LIBUI = -lX11 -lXmu -lXrandr -lXxf86vm -lXi
  LIBFTGL = -lftgl -lfreetype -lpng -lbz2 -lbrotlidec -lbrotlienc -lbrotlicommon -lz
endif

ifdef BUILD_WITH_MINGW
  LIBGLUT = -lfreeglut_static
  LIBGLU = -lglu32
  LIBGL= -lopengl32
  LIBUI = -lgdi32 -lwinmm
  LIBFTGL = -lftgl -lfreetype -lpng -lbz2 -lbrotlidec -lbrotlienc -lbrotlicommon -lz
endif

PROGS = uc2 ucn
# make this optional so compile doesn't break on systems without OpenGL
GUI_PROGS = uc2_graphics slide_show

ifdef BUILD_WITH_GUI
  $(info building gui apps)
  PROGS += $(GUI_PROGS)
endif

$(info All PROGS=$(PROGS))

all: $(PROGS)

gui: $(GUI_PROGS)

libstdc++.a:
	ln -s `$(CXX) $(CXXFLAGS) -print-file-name=libstdc++.a`

ttfont.cpp:
	ln -s ../../api/ttfont.cpp .

clean: distclean

distclean:
	/bin/rm -f $(PROGS) $(GUI_PROGS) $(addsuffix .exe, $(PROGS)) $(addsuffix .exe, $(GUI_PROGS)) *.o libstdc++.a ttfont.cpp

install: all

# specify library paths explicitly (rather than -l)
# because otherwise you might get a version in /usr/lib etc.

uc2: uc2.o $(MAKEFILE_STDLIB) $(BOINC_API_DIR)/libboinc_api.a $(BOINC_LIB_DIR)/libboinc.a
	$(CXX) $(CXXFLAGS) $(CPPFLAGS) $(LDFLAGS) -o uc2 uc2.o \
	-lboinc_api -lboinc $(MAKEFILE_LDFLAGS) \
	$(STDCPPTC)

ucn: ucn.o $(MAKEFILE_STDLIB) $(BOINC_API_DIR)/libboinc_api.a $(BOINC_LIB_DIR)/libboinc.a
	$(CXX) $(CXXFLAGS) $(CPPFLAGS) $(LDFLAGS) -o ucn ucn.o \
	-lboinc_api -lboinc $(MAKEFILE_LDFLAGS) \
	$(STDCPPTC)

uc2_graphics: uc2_graphics.o ttfont.o $(MAKEFILE_STDLIB) $(BOINC_LIB_DIR)/libboinc.a $(BOINC_API_DIR)/libboinc_graphics2.a
	$(CXX) $(CXXFLAGS) $(CPPFLAGS) $(LDFLAGS) -o uc2_graphics uc2_graphics.o ttfont.o $(MAKEFILE_LDFLAGS) \
	$(BOINC_API_DIR)/libboinc_graphics2.a \
	$(BOINC_API_DIR)/libboinc_api.a \
	$(BOINC_LIB_DIR)/libboinc.a \
    $(LIBGLUT) $(LIBGLU) $(LIBJPEG) \
    $(LIBFTGL) $(LIBGL) $(LIBUI) -lm

slide_show: slide_show.o $(MAKEFILE_STDLIB) $(BOINC_LIB_DIR)/libboinc.a $(BOINC_API_DIR)/libboinc_graphics2.a
	$(CXX) $(CXXFLAGS) -o slide_show slide_show.o $(MAKEFILE_LDFLAGS) \
	$(MINGW_ZIP_FIX) \
	$(BOINC_API_DIR)/libboinc_graphics2.a \
	$(BOINC_API_DIR)/libboinc_api.a \
	$(BOINC_LIB_DIR)/libboinc.a \
	$(BOINC_ZIP_DIR)/libboinc_zip.a \
    $(LIBGLUT) $(LIBGLU) $(LIBJPEG) \
    $(LIBGL) $(LIBUI) -lm

=== samples/multi_thread/Makefile ===
# This should work on Linux.  Modify as needed for other platforms.

ifdef ANDROID
  MULTITHREAD_RELEASE_SUFFIX =
else
  ifdef RELEASE_ARCH
    MULTITHREAD_RELEASE_SUFFIX = _$(MULTITHREAD_RELEASE_VERSION)_$(RELEASE_ARCH)-pc-linux-gnu
  else
    MULTITHREAD_RELEASE_SUFFIX = _$(MULTITHREAD_RELEASE_VERSION)_x86_64-pc-linux-gnu
  endif
endif

BOINC_DIR = ../..
BOINC_SOURCE_API_DIR = $(BOINC_DIR)/api
BOINC_SOURCE_LIB_DIR = $(BOINC_DIR)/lib
BOINC_SOURCE_ZIP_DIR = $(BOINC_DIR)/zip

ifdef ANDROID
  BOINC_API_DIR = $(TCINCLUDES)/lib
  BOINC_LIB_DIR = $(TCINCLUDES)/lib
  BOINC_ZIP_DIR = $(TCINCLUDES)/lib

  MAKEFILE_LDFLAGS =
  MAKEFILE_STDLIB  =
else
  BOINC_API_DIR = $(BOINC_SOURCE_API_DIR)
  BOINC_LIB_DIR = $(BOINC_SOURCE_LIB_DIR)
  BOINC_ZIP_DIR = $(BOINC_SOURCE_ZIP_DIR)

  MAKEFILE_LDFLAGS = libstdc++.a -lpthread
  MAKEFILE_STDLIB  = libstdc++.a
endif

CXXFLAGS += -g \
    -I$(BOINC_DIR) \
    -I$(BOINC_SOURCE_API_DIR) \
    -I$(BOINC_SOURCE_LIB_DIR) \
    -L$(BOINC_API_DIR) \
    -L$(BOINC_LIB_DIR) \
    -L.

PROG = multi_thread$(MULTITHREAD_RELEASE_SUFFIX)

all: $(PROG)

libstdc++.a:
	ln -s `$(CXX) $(CXXFLAGS) -print-file-name=libstdc++.a`

clean: distclean

distclean:
	/bin/rm -f $(PROG) $(addsuffix .exe, $(PROG)) *.o libstdc++.a

$(PROG): multi_thread.o $(MAKEFILE_STDLIB) $(BOINC_API_DIR)/libboinc_api.a $(BOINC_LIB_DIR)/libboinc.a
	$(CXX) $(CXXFLAGS) $(CPPFLAGS) $(LDFLAGS) -o $(PROG) multi_thread.o $(MAKEFILE_LDFLAGS) -lboinc_api -lboinc $(STDCPPTC)

install: all

=== samples/openclapp/Makefile ===
# makefile for openclapp BOINC example appication using AMD GPU on Linux.

BOINC_DIR = ../..
BOINC_SOURCE_API_DIR = $(BOINC_DIR)/api
BOINC_SOURCE_LIB_DIR = $(BOINC_DIR)/lib
BOINC_SOURCE_ZIP_DIR = $(BOINC_DIR)/zip

ifndef ANDROID
  BOINC_API_DIR = $(BOINC_SOURCE_API_DIR)
  BOINC_LIB_DIR = $(BOINC_SOURCE_LIB_DIR)
  BOINC_ZIP_DIR = $(BOINC_SOURCE_ZIP_DIR)
else
  BOINC_API_DIR = $(TCINCLUDES)/lib
  BOINC_LIB_DIR = $(TCINCLUDES)/lib
  BOINC_ZIP_DIR = $(TCINCLUDES)/lib
endif

CXXFLAGS += -g \
    -I$(BOINC_DIR) \
    -I$(BOINC_SOURCE_API_DIR) \
    -I$(BOINC_SOURCE_LIB_DIR) \
    -I$(AMDAPPSDKROOT)/include \
    -I/usr/local/cuda/include \
    -L. \
    -L$(BOINC_API_DIR) \
    -L$(BOINC_LIB_DIR) \
    -L$(AMDAPPSDKROOT)/lib/x86 \
    -L/usr/local/cuda/lib \
    -L/lib/i386-linux-gnu

## The above 2 lines work around an Ubuntu LD_LIBRARY_PATH bug described in:
## <https://help.ubuntu.com/community/EnvironmentVariables#File-location_related_variables>

PROGS = openclapp

all: $(PROGS)

libstdc++.a:
	ln -s `$(CXX) -print-file-name=libstdc++.a`

clean:
	/bin/rm -f $(PROGS) *.o libstdc++.a

distclean:
	/bin/rm -f $(PROGS) *.o libstdc++.a

install: all

openclapp: openclapp.o boinc_opencl.o libstdc++.a
	$(CXX) $(CXXFLAGS) -o openclapp openclapp.o boinc_opencl.o \
        libstdc++.a -lOpenCL -lboinc_api -lboinc -lpthread

openclapp.o: openclapp.cpp openclapp.hpp
	$(CXX) $(CXXFLAGS) -c openclapp.cpp

boinc_opencl.o: $(BOINC_API_DIR)/boinc_opencl.cpp $(BOINC_API_DIR)/boinc_opencl.h
	$(CXX) $(CXXFLAGS) -c $(BOINC_API_DIR)/boinc_opencl.cpp

=== samples/sporadic/Makefile ===

BOINC_DIR = ../..
BOINC_SOURCE_API_DIR = $(BOINC_DIR)/api
BOINC_SOURCE_LIB_DIR = $(BOINC_DIR)/lib
BOINC_SOURCE_ZIP_DIR = $(BOINC_DIR)/zip

ifdef ANDROID
  BOINC_API_DIR = $(TCINCLUDES)/lib
  BOINC_LIB_DIR = $(TCINCLUDES)/lib
  BOINC_ZIP_DIR = $(TCINCLUDES)/lib

  MAKEFILE_LDFLAGS =
  MAKEFILE_STDLIB  =
else
  BOINC_API_DIR = $(BOINC_SOURCE_API_DIR)
  BOINC_LIB_DIR = $(BOINC_SOURCE_LIB_DIR)
  BOINC_ZIP_DIR = $(BOINC_SOURCE_ZIP_DIR)

  MAKEFILE_LDFLAGS = -lpthread libstdc++.a
  MAKEFILE_STDLIB  = libstdc++.a
endif

CXXFLAGS += -g \
	-Wall -W -Wshadow -Wpointer-arith -Wcast-qual -Wcast-align -Wwrite-strings -fno-common \
    -I$(BOINC_DIR) \
    -I$(BOINC_SOURCE_API_DIR) \
    -I$(BOINC_SOURCE_LIB_DIR) \
    -I$(BOINC_SOURCE_ZIP_DIR) \
    -L$(BOINC_API_DIR) \
    -L$(BOINC_LIB_DIR) \
    -L.

ifdef BUILD_APPS_WITH_VCPKG
  BUILD_DIR     = $(BOINC_DIR)/3rdParty/linux
  VCPKG_DIR     ?= $(BUILD_DIR)/vcpkg/installed/x64-linux

  CXXFLAGS += \
    -I$(VCPKG_DIR)/include \
    -L$(VCPKG_DIR)/lib
endif

all: sporadic

libstdc++.a:
	ln -s `$(CXX) $(CXXFLAGS) -print-file-name=libstdc++.a`

clean: distclean

distclean:
	/bin/rm -f sporadic $(addsuffix .exe, sporadic) *.o libstdc++.a

install: all

sporadic: sporadic.o $(MAKEFILE_STDLIB) $(BOINC_API_DIR)/libboinc_api.a $(BOINC_LIB_DIR)/libboinc.a
	$(CXX) $(CXXFLAGS) $(CPPFLAGS) $(LDFLAGS) -o sporadic sporadic.o \
	-lboinc_api -lboinc $(MAKEFILE_LDFLAGS) \
	$(STDCPPTC)

=== samples/vboxmonitor/Makefile ===
# This should work on Linux.  Modify as needed for other platforms.

# Change the following to match your installation
BOINC_DIR = ../..
BOINC_SOURCE_API_DIR = $(BOINC_DIR)/api
BOINC_SOURCE_LIB_DIR = $(BOINC_DIR)/lib
BOINC_SOURCE_ZIP_DIR = $(BOINC_DIR)/zip

ifdef ANDROID
  BOINC_API_DIR = $(TCINCLUDES)/lib
  BOINC_LIB_DIR = $(TCINCLUDES)/lib
  BOINC_ZIP_DIR = $(TCINCLUDES)/lib

  MAKEFILE_LDFLAGS =
  MAKEFILE_STDLIB  =
else
  BOINC_API_DIR = $(BOINC_SOURCE_API_DIR)
  BOINC_LIB_DIR = $(BOINC_SOURCE_LIB_DIR)
  BOINC_ZIP_DIR = $(BOINC_SOURCE_ZIP_DIR)

  MAKEFILE_LDFLAGS = libstdc++.a -lpthread
  MAKEFILE_STDLIB  = libstdc++.a
endif

CXXFLAGS += -g \
	-Wall -W -Wshadow -Wpointer-arith -Wcast-qual -Wcast-align -Wwrite-strings -fno-common \
    -I$(BOINC_DIR) \
    -I$(BOINC_SOURCE_API_DIR) \
    -I$(BOINC_SOURCE_LIB_DIR) \
    -L$(BOINC_API_DIR) \
    -L$(BOINC_LIB_DIR) \
    -L.

PROGS = vboxmonitor

all: $(PROGS)

libstdc++.a:
	ln -s `$(CXX) $(CXXFLAGS) -print-file-name=libstdc++.a`

clean: distclean

distclean:
	/bin/rm -f $(PROGS) *.o libstdc++.a

vboxmonitor: vboxmonitor.o $(MAKEFILE_STDLIB) $(BOINC_LIB_DIR)/libboinc.a $(BOINC_API_DIR)/libboinc_api.a
	$(CXX) $(CXXFLAGS) $(CPPFLAGS) $(LDFLAGS) -o vboxmonitor vboxmonitor.o $(MAKEFILE_LDFLAGS) -lboinc_api -lboinc $(STDCPPTC)

install: all

=== samples/vboxwrapper/Makefile ===
# This should work on Linux.  Modify as needed for other platforms.

ifdef ANDROID
  VBOXWRAPPER_RELEASE_SUFFIX =
else
  ifdef RELEASE_ARCH
    VBOXWRAPPER_RELEASE_SUFFIX = _$(VBOXWRAPPER_RELEASE_VERSION)_$(RELEASE_ARCH)-pc-linux-gnu
  else
    VBOXWRAPPER_RELEASE_SUFFIX = _$(VBOXWRAPPER_RELEASE_VERSION)_x86_64-pc-linux-gnu
  endif
endif

# Change the following to match your installation
BOINC_DIR = ../..
BOINC_SOURCE_API_DIR = $(BOINC_DIR)/api
BOINC_SOURCE_LIB_DIR = $(BOINC_DIR)/lib
BOINC_SOURCE_ZIP_DIR = $(BOINC_DIR)/zip

ifdef ANDROID
  BOINC_API_DIR = $(TCINCLUDES)/lib
  BOINC_LIB_DIR = $(TCINCLUDES)/lib
  BOINC_ZIP_DIR = $(TCINCLUDES)/lib

  MAKEFILE_LDFLAGS =
  MAKEFILE_STDLIB  =
else
  BOINC_API_DIR = $(BOINC_SOURCE_API_DIR)
  BOINC_LIB_DIR = $(BOINC_SOURCE_LIB_DIR)
  BOINC_ZIP_DIR = $(BOINC_SOURCE_ZIP_DIR)

  MAKEFILE_LDFLAGS = libstdc++.a -lpthread
  MAKEFILE_STDLIB  = libstdc++.a
endif

CXXFLAGS += -g \
	-Wall -W -Wshadow -Wpointer-arith -Wcast-qual -Wcast-align -Wwrite-strings -fno-common \
    -I$(BOINC_DIR) \
    -I$(BOINC_SOURCE_API_DIR) \
    -I$(BOINC_SOURCE_LIB_DIR) \
    -L$(BOINC_API_DIR) \
    -L$(BOINC_LIB_DIR) \
    -L.

PROGS = vboxwrapper$(VBOXWRAPPER_RELEASE_SUFFIX)

HEADERS = vbox_common.h vboxjob.h vbox_vboxmanage.h vboxwrapper.h

all: $(PROGS)

libstdc++.a:
	ln -s `$(CXX) $(CXXFLAGS) -print-file-name=libstdc++.a`

clean: distclean

distclean:
	/bin/rm -f $(PROGS) *.o libstdc++.a

floppyio.o: floppyio.cpp
	$(CXX) $(CXXFLAGS) $(CPPFLAGS) -c floppyio.cpp

vbox_common.o: vbox_common.cpp $(HEADERS)
	$(CXX) $(CXXFLAGS) $(CPPFLAGS) -c vbox_common.cpp

vbox_vboxmanage.o: vbox_vboxmanage.cpp $(HEADERS)
	$(CXX) $(CXXFLAGS) $(CPPFLAGS) -c vbox_vboxmanage.cpp

vboxcheckpoint.o: vboxcheckpoint.cpp $(HEADERS)
	$(CXX) $(CXXFLAGS) $(CPPFLAGS) -c vboxcheckpoint.cpp

vboxjob.o: vboxjob.cpp $(HEADERS)
	$(CXX) $(CXXFLAGS) $(CPPFLAGS) -c vboxjob.cpp

vboxlogging.o: vboxlogging.cpp $(HEADERS)
	$(CXX) $(CXXFLAGS) $(CPPFLAGS) -c vboxlogging.cpp

vboxwrapper.o: vboxwrapper.cpp $(HEADERS)
	$(CXX) $(CXXFLAGS) $(CPPFLAGS) -c vboxwrapper.cpp

vboxwrapper$(VBOXWRAPPER_RELEASE_SUFFIX): vboxwrapper.o vbox_common.o vbox_vboxmanage.o vboxcheckpoint.o vboxjob.o vboxlogging.o floppyio.o $(MAKEFILE_STDLIB) $(BOINC_LIB_DIR)/libboinc.a $(BOINC_API_DIR)/libboinc_api.a
	$(CXX) $(CXXFLAGS) $(CPPFLAGS) $(LDFLAGS) -o vboxwrapper$(VBOXWRAPPER_RELEASE_SUFFIX) vboxwrapper.o vbox_common.o vbox_vboxmanage.o vboxcheckpoint.o vboxjob.o vboxlogging.o floppyio.o $(MAKEFILE_LDFLAGS) -lboinc_api -lboinc -lrt $(STDCPPTC)

install: all

=== samples/worker/Makefile ===
#CXXFLAGS += -g
CXX ?= g++

ifdef ANDROID
	WORKER_RELEASE_SUFFIX =
else
	ifdef RELEASE_ARCH
		WORKER_RELEASE_SUFFIX = _$(WORKER_RELEASE_VERSION)_$(RELEASE_ARCH)-pc-linux-gnu
	else
		WORKER_RELEASE_SUFFIX = _$(WORKER_RELEASE_VERSION)_x86_64-pc-linux-gnu
	endif
endif

PROGS = worker$(WORKER_RELEASE_SUFFIX)

all: $(PROGS)

clean: distclean

distclean:
	rm -f $(PROGS) $(addsuffix .exe, $(PROGS)) *.o

worker$(WORKER_RELEASE_SUFFIX): worker.cpp
	$(CXX) $(CXXFLAGS) $(CPPFLAGS) $(LDFLAGS) -o worker$(WORKER_RELEASE_SUFFIX) worker.cpp

install: all

.PHONY: install all distclean clean

=== samples/wrappture/Makefile ===
# This should work on Linux.  Modify as needed for other platforms.

# Change the following to match your installation
BOINC_DIR = ../..
BOINC_SOURCE_API_DIR = $(BOINC_DIR)/api
BOINC_SOURCE_LIB_DIR = $(BOINC_DIR)/lib
BOINC_SOURCE_ZIP_DIR = $(BOINC_DIR)/zip

ifdef ANDROID
  BOINC_API_DIR = $(TCINCLUDES)/lib
  BOINC_LIB_DIR = $(TCINCLUDES)/lib
  BOINC_ZIP_DIR = $(TCINCLUDES)/lib
  MAKEFILE_LDFLAGS =
  MAKEFILE_STDLIB  =
else
  BOINC_API_DIR = $(BOINC_SOURCE_API_DIR)
  BOINC_LIB_DIR = $(BOINC_SOURCE_LIB_DIR)
  BOINC_ZIP_DIR = $(BOINC_SOURCE_ZIP_DIR)
  BUILD_DIR     = $(BOINC_DIR)/3rdParty/linux
  VCPKG_DIR     ?= $(BUILD_DIR)/vcpkg/installed/x64-linux
  MAKEFILE_LDFLAGS = libstdc++.a -lpthread
  MAKEFILE_STDLIB  = libstdc++.a
endif

RAPPTURE_DIR ?= $(VCPKG_DIR)/include/rappture

CXXFLAGS += -g \
    -I$(BOINC_DIR) \
    -I$(BOINC_SOURCE_API_DIR) \
    -I$(BOINC_SOURCE_LIB_DIR) \
    -I$(VCPKG_DIR)/include \
    -I$(RAPPTURE_DIR) \
    -L$(BOINC_API_DIR) \
    -L$(BOINC_LIB_DIR) \
    -L$(VCPKG_DIR)/lib \
    -L.

PROGS = wrappture_example fermi

all: $(PROGS)

libstdc++.a:
	ln -s `$(CXX) $(CXXFLAGS) -print-file-name=libstdc++.a`

clean: distclean

distclean:
	/bin/rm -f $(PROGS) $(addsuffix .exe, $(PROGS)) *.o libstdc++.a

wrappture.o: wrappture.cpp
	$(CXX) $(CXXFLAGS) $(CPPFLAGS) -c -o wrappture.o wrappture.cpp

wrappture_example: wrappture.o wrappture_example.o $(MAKEFILE_STDLIB) $(BOINC_LIB_DIR)/libboinc.a $(BOINC_API_DIR)/libboinc_api.a $(VCPKG_DIR)/lib/librappture.a
	$(CXX) $(CXXFLAGS) $(CPPFLAGS) $(LDFLAGS) -o wrappture_example wrappture_example.o wrappture.o -lboinc_api -lboinc -lrappture -lexpat -lz $(MAKEFILE_LDFLAGS)

fermi: fermi.cpp
	$(CXX) $(CXXFLAGS) $(CPPFLAGS) $(LDFLAGS) -o fermi fermi.cpp

install: all

=== tests/unit-tests/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.21)

project(BOINC_unit_testing)
enable_testing()

set (CMAKE_CXX_STANDARD 11)
set (CMAKE_CXX_FLAGS "-g -Wall -Wextra -Werror --coverage")

if (APPLE)
    find_package(GTest REQUIRED PATHS ${PROJECT_SOURCE_DIR}/../../3rdParty/osx/vcpkg/installed/arm64-osx/share NO_DEFAULT_PATH)
else()
    find_package(Threads REQUIRED)
    find_package(GTest REQUIRED)
endif()

# There is no easy way to interface with the autotools driven build system in boinc
# so the paths below are hardcoded and are mainly suited for building on Travis CI
# TODO: make paths configurable and generate them from boinc make or switch boinc to cmake

if (APPLE)
    include_directories(BEFORE "${PROJECT_SOURCE_DIR}/../../3rdParty/osx/vcpkg/installed/arm64-osx/include")
    include_directories("${PROJECT_SOURCE_DIR}/../../lib")
else()
    include_directories(BEFORE "${PROJECT_SOURCE_DIR}/../../3rdParty/buildCache/linux/include")
    include_directories("${PROJECT_SOURCE_DIR}/../..")
    include_directories("${PROJECT_SOURCE_DIR}/../../sched")
    include_directories("${PROJECT_SOURCE_DIR}/../../db")
    include_directories("${PROJECT_SOURCE_DIR}/../../lib")
    include_directories("${PROJECT_SOURCE_DIR}/../../tools")
    include_directories("/usr/include/mariadb")
    include_directories("/usr/include/mariadb/mysql")
    include_directories("/usr/include/mysql")
endif()

if (APPLE)
    find_library(BOINC_LIB libboinc.a PATHS ${PROJECT_SOURCE_DIR}/../../build-arm64-osx NO_DEFAULT_PATH)
else()
    find_library(SCHED_LIB libsched.a PATHS ${PROJECT_SOURCE_DIR}/../../sched NO_DEFAULT_PATH)
    find_library(BOINC_CRYPT_LIB libboinc_crypt.a PATHS ${PROJECT_SOURCE_DIR}/../../lib NO_DEFAULT_PATH)
    find_library(BOINC_LIB libboinc.a PATHS ${PROJECT_SOURCE_DIR}/../../lib NO_DEFAULT_PATH)
    find_library(MYSQL_LIB NAMES mariadb mysqlclient)
    message(STATUS "mysql_lib: ${MYSQL_LIB}")
endif()

add_subdirectory(lib)
if (NOT APPLE)
    add_subdirectory(sched)
endif()

=== debian/control ===
Source: boinc
Maintainer: Debian BOINC Maintainers <pkg-boinc-devel@lists.alioth.debian.org>
Uploaders: Steffen Moeller <moeller@debian.org>,
           Guo Yixuan (郭溢譞) <culu.gyx@gmail.com>,
           Gianfranco Costamagna <locutusofborg@debian.org>
Section: net
Priority: optional
Build-Depends: debhelper-compat (= 13),
               default-libmysqlclient-dev,
               dh-python,
               docbook-xml,
               docbook2x,
               dpkg-dev (>= 1.16.1.1),
               freeglut3-dev,
               gettext,
               libcurl4-openssl-dev,
               libfcgi-dev,
               libgtk-3-dev,
               libice-dev,
               libjpeg-dev,
               libnotify-dev,
               libsm-dev,
               libsqlite3-dev,
               libssl-dev,
               libtool,
               libwxgtk-webview3.2-dev,
               libxcb-util0-dev,
               libxi-dev,
               libxml2-utils,
               libxmu-dev,
               libxss-dev,
               opencl-c-headers,
               pkg-config,
               po-debconf,
               python3-all,
               python3-setuptools,
               zlib1g-dev
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/pkg-boinc-team/boinc
Vcs-Git: https://salsa.debian.org/pkg-boinc-team/boinc.git
Homepage: https://boinc.berkeley.edu/
Rules-Requires-Root: no

Package: boinc
Architecture: all
Depends: boinc-client (>= ${source:Version}),
         boinc-manager (>= ${source:Version}),
         ${misc:Depends}
Description: metapackage for the BOINC client and the manager
 The Berkeley Open Infrastructure for Network Computing (BOINC) is a
 software platform for distributed computing: several initiatives of
 various scientific disciplines all compete for the idle time of
 desktop computers. The developers' web site at the University of
 Berkeley serves as a common portal to the otherwise independently run
 projects.
 .
 This package depends both on the BOINC core client program that is
 required to participate in any project that uses BOINC, and the
 BOINC Manager, a graphical monitor and control utility for the
 BOINC core client.

Package: boinc-virtualbox
Architecture: amd64
Section: contrib/misc
Depends: ${misc:Depends},
         boinc-client
Recommends: virtualbox | virtualbox-6.1 | virtualbox-6.0 | virtualbox-5.2 | virtualbox-5.1 | virtualbox-5.0,
            virtualbox-ext-pack
Description: metapackage for virtualbox-savvy projects
 The Berkeley Open Infrastructure for Network Computing (BOINC) is a
 software platform for distributed computing: several initiatives of
 various scientific disciplines all compete for the idle time of
 desktop computers. The developers' web site at the University of
 Berkeley serves as a common portal to the otherwise independently run
 projects.
 .
 Regular users (righteously) often find it an unbearable nuisance to
 care for the exact configuration of BOINC for virtualbox-based projects.
 This package adds a series of dependencies from the contrib
 section to the regular boinc package. This also meant this binary
 package to be redistributed in the contrib section of Debian.

Package: boinc-client-nvidia-cuda
Architecture: amd64 i386 armhf
Section: contrib/net
Breaks: boinc-nvidia-cuda
Replaces: boinc-nvidia-cuda
Depends: ${misc:Depends},
         boinc-client
Recommends: libcuda1
Description: metapackage for CUDA-savvy BOINC client and manager
 The Berkeley Open Infrastructure for Network Computing (BOINC) is a
 software platform for distributed computing: several initiatives of
 various scientific disciplines all compete for the idle time of
 desktop computers. The developers' web site at the University of
 Berkeley serves as a common portal to the otherwise independently run
 projects.
 .
 Regular users (righteously) often find it an unbearable nuisance to
 care for the exact configuration of BOINC for CUDA-savvy graphics
 cards. This package adds a series of dependencies from the non-free
 section to the regular boinc package. This also meant this binary
 package to be redistributed in the contrib section of Debian.

Package: boinc-client-opencl
Architecture: any
Section: contrib/net
Breaks: boinc-amd-opencl
Replaces: boinc-amd-opencl
Depends: ${misc:Depends},
         ocl-icd-libopencl1
Recommends: amd-opencl-icd | opencl-icd
Description: metapackage for AMD/ATI OpenCL-savvy BOINC client and manager
 The Berkeley Open Infrastructure for Network Computing (BOINC) is a
 software platform for distributed computing: several initiatives of
 various scientific disciplines all compete for the idle time of
 desktop computers. The developers' web site at the University of
 Berkeley serves as a common portal to the otherwise independently run
 projects.
 .
 Regular users (righteously) often find it an unbearable nuisance to
 care for the configuration of BOINC for the OpenCL-savvy AMD/ATI
 graphics cards.  This package adds a series of dependencies from the
 non-free section to the regular boinc package. This also meant this
 binary package to be redistributed in the contrib section of Debian.

Package: boinc-client
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends},
         adduser,
         ca-certificates,
         lsb-base (>= 3.0-6),
         libboinc7t64 (= ${binary:Version})
Suggests: boinc-manager,
          boinc-client-opencl,
          boinc-client-nvidia-cuda,
          x11-xserver-utils
Description: core client for the BOINC distributed computing infrastructure
 The Berkeley Open Infrastructure for Network Computing (BOINC) is a
 software platform for distributed computing: several initiatives of
 various scientific disciplines all compete for the idle time of
 desktop computers. The developers' web site at the University of
 Berkeley serves as a common portal to the otherwise independently run
 projects.
 .
 This package contains the BOINC core client program that is required
 to participate in any project that uses BOINC. A central server
 distributes work units and collects results via this client. When
 attaching a local machine to a project, this client will also
 dynamically download the scientific data and executables to be then
 wrapped by the BOINC core client.

Package: boinc-screensaver
Architecture: any
Section: x11
Depends: boinc-client,
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: boinc-manager
Description: screen saver auto-controlling volunteer computing
 The Berkeley Open Infrastructure for Network Computing (BOINC) is a
 software platform for distributed computing: several initiatives of
 various scientific disciplines all compete for the idle time of
 desktop computers. The developers' web site at the University of
 Berkeley serves as a common portal to the otherwise independently run
 projects.
 .
 The BOINC client is configurable by the command line or the BOINC
 manager's GUI to compute with any range between 0% and 100% of
 available resources, and to change that ratio to a higher after
 some user determined duration of inactivity. There is now quite
 a number of individuals who prefer to have everything presented
 with their accustomed principle for setting and choosing a screen
 saver. Upon inactivity, the BOINC client is started, and stopped
 again when the user is back. To save the screen, it then shows
 the graphical progress indication as optionally shown also by
 the manager.
 .
 This package is excellent to further promote BOINC, recalling the
 effect SETI@Home once had in the Cambridge, UK, CB2 Cybercafe.
 Just, when using it together with the regular BOINC client setup,
 it is suggested not to have all CPUs used to avoid multiple
 processes running on the same core.

Package: boinc-manager
Architecture: any
Section: x11
Depends: ${misc:Depends},
         ${shlibs:Depends},
         boinc-client
Suggests: libgl1-mesa-glx, libxt6
Description: GUI to control and monitor the BOINC core client
 The Berkeley Open Infrastructure for Network Computing (BOINC) is a
 software platform for distributed computing using volunteered computer
 resources.
 .
 This package contains the BOINC Manager, a graphical monitor and
 control utility for the BOINC core client. It gives a detailed
 overview of the state of the client it is monitoring, as there are
  * attached projects
  * running tasks
  * file transfers between the client and project servers
  * statistics about granted credits and disk usage for every project
  * constraints on CPU usage
 The BOINC Manager has two modes of operation, the "Simple View" in which
 it only displays the most important information and the "Advanced View"
 in which all information and all control elements are available.
 .
 For active participation in any BOINC project the recommended
 boinc-client package, not the boinc-manager, is required for every
 machine contributing.

Package: boinc-dev
Architecture: any
Section: oldlibs
Depends: libboinc-app-dev (= ${binary:Version}), ${misc:Depends}
Description: development files to build applications for BOINC projects (transitional)
 Dummy transitional package helping the transition of a split of
 architecture-independent development files and the architecture-dependent
 dynamic libraries.  Static libraries are no longer redistributed.

Package: libboinc-app-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends},
         libboinc-app7t64 (= ${binary:Version}),
         libboinc7t64 (= ${binary:Version}),
         libc6-dev | libc-dev,
         default-libmysqlclient-dev,
         libssl-dev,
         build-essential
Breaks: boinc-dev (<< 7.0.28+dfsg-3)
Replaces: boinc-dev (<< 7.0.28+dfsg-3)
Description: development files to build applications for BOINC projects
 The Berkeley Open Infrastructure for Network Computing (BOINC) is a
 software platform for distributed computing using volunteered computer
 resources.
 .
 This package contains header files that are needed to develop and
 compile applications which utilizes the BOINC infrastructure.
 The package also provides static libraries. These are needed for the
 development of scientific applications that work seamlessly across
 many Linux distributions and different releases of the same.

Package: libboinc-app7t64
Architecture: any
Section: libs
Provides: libboinc-app, ${t64:Provides}
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Breaks: libboinc-app7 (<< ${source:Version}), boinc-dev (<< 7.0.28+dfsg-3),
        libboinc-app (<= 7.0.34+dfsg-1)
Replaces: libboinc-app7, boinc-dev (<< 7.0.28+dfsg-3),
          libboinc-app (<= 7.0.34+dfsg-1)
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: libraries for BOINC's scientific applications
 The Berkeley Open Infrastructure for Network Computing (BOINC) is a
 software platform for distributed computing using volunteered computer
 resources.
 .
 This package contains dynamic libraries that are needed for applications
 which utilizes the BOINC infrastructure and the boinc-client itself.

Package: libboinc7t64
Architecture: any
Section: libs
Provides: libboinc, ${t64:Provides}
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Breaks: libboinc7 (<< ${source:Version}), boinc-dev (<< 7.0.28+dfsg-3),
        libboinc (<= 7.0.34+dfsg-1)
Replaces: libboinc7, boinc-dev (<< 7.0.28+dfsg-3),
          libboinc (<= 7.0.34+dfsg-1)
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: libraries of BOINC the client depends on
 The Berkeley Open Infrastructure for Network Computing (BOINC) is a
 software platform for distributed computing using volunteered computer
 resources.
 .
 The environment offers a series of libraries that both the user-run
 client and the client-invoked scientific applications depend on. With
 the number of cores per machine growing, and with scientific apps
 commonly started for every core, it is essential to have memory
 shared as much as possible between binaries of all projects.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Uncomment the following lines to compile with gcc-snapshot.
#export  CC=/usr/lib/gcc-snapshot/bin/gcc
#export CXX=/usr/lib/gcc-snapshot/bin/g++
#export CPP=/usr/lib/gcc-snapshot/bin/cpp

export CPPFLAGS := $(shell dpkg-buildflags --get CPPFLAGS)
export CFLAGS   := $(shell dpkg-buildflags --get CFLAGS)
export CXXFLAGS := $(shell dpkg-buildflags --get CXXFLAGS)
export LDFLAGS  := $(shell dpkg-buildflags --get LDFLAGS)

# BOINC client itself is not time-critical and may be an older machine with no AVX yet
#ARCH_AVX := i386 amd64 x32 hurd-i386
#ifneq (,$(findstring $(DEB_HOST_ARCH),$(ARCH_AVX)))
#  CPPFLAGS += -mavx
#  CXXFLAGS += -mavx
#endif

#export CXX=clang++
export AR=ar
export RANLIB=ranlib

DEB_HOST_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

# Set default flags with dpkg-buildflags
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

ifeq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
  TYPE_FLAGS = --build $(DEB_HOST_GNU_TYPE)
else
  TYPE_FLAGS = --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE)
endif

# On some architectures it is required to change the BOINC platform of the
# core client (with the --with-boinc-platform configure option) to match the
# official BOINC platform, otherwise it would not download any applications,
# because projects mostly provide applications for official BOINC platforms
# only. See https://boinc.berkeley.edu/trac/wiki/BoincPlatforms for the list
# of official BOINC platforms.
#
# The table of architectures known to dpkg-architecture are listed on
#  /usr/share/dpkg/archtable

# Change BOINC platform alpha-unknown-linux-gnu to alpha-hp-linux-gnu and
# declare alpha-unknown-linux-gnu as alternate platform, because some projects
# offer applications for it.
ifeq ($(DEB_HOST_GNU_TYPE), alpha-linux-gnu)
  TYPE_FLAGS += --with-boinc-platform=alpha-hp-linux-gnu \
    --with-boinc-alt-platform=alpha-unknown-linux-gnu
endif

# Change BOINC platform i486-pc-linux-gnu to i686-pc-linux-gnu.
ifeq ($(DEB_HOST_GNU_TYPE), i486-linux-gnu)
  TYPE_FLAGS += --with-boinc-platform=i686-pc-linux-gnu
endif

# Change BOINC platform x86_64-linux-gnu to x86_64-pc-linux-gnu.
# Keeping the previous name temporarily.
# The 32bit variants shall allow the execution of 32 bit
# executable in case the scientific application is no available
# for the complete bit size.
ifeq ($(DEB_HOST_GNU_TYPE), x86_64-linux-gnu)
  TYPE_FLAGS += --with-boinc-platform=x86_64-pc-linux-gnu
  # wrong previous name (since regular Debian name)
  TYPE_FLAGS += --with-boinc-alt-platform=x86_64-linux-gnu
  # if we did the following, the the ia32 libs would
  # need to become a dependency - which is not wanted by too many
  #TYPE_FLAGS += --with-boinc-alt-platform=i686-pc-linux-gnu
endif

# Change BOINC platform i486-pc-kfreebsd-gnu to i686-pc-kfreebsd-gnu to be
# consistent with the official BOINC platform i686-pc-linux-gnu.
ifeq ($(DEB_HOST_GNU_TYPE), i486-kfreebsd-gnu)
  TYPE_FLAGS += --with-boinc-platform=i686-pc-kfreebsd-gnu
endif

# Declare i686-pc-kfreebsd-gnu as alternate platform for
# x86_64-pc-kfreebsd-gnu.
ifeq ($(DEB_HOST_GNU_TYPE), x86_64-kfreebsd-gnu)
  TYPE_FLAGS += --with-boinc-platform=x86_64-pc-kfreebsd-gnu
  TYPE_FLAGS += --with-boinc-alt-platform=i686-pc-kfreebsd-gnu
endif

# Change BOINC platform ia64-unknown-linux-gnu to ia64-linux-gnu.
ifeq ($(DEB_HOST_GNU_TYPE), ia64-linux-gnu)
  TYPE_FLAGS += --with-boinc-platform=ia64-linux-gnu
endif

# Change BOINC platform powerpc-unknown-linux-gnu to powerpc-linux-gnu.
ifeq ($(DEB_HOST_GNU_TYPE), powerpc-linux-gnu)
  TYPE_FLAGS += --with-boinc-platform=powerpc-linux-gnu
endif

# Change BOINC platform powerpc64-unknown-linux-gnu to ppc64-linux-gnu and
# declare powerpc-linux-gnu as alternate platform.
ifeq ($(DEB_HOST_GNU_TYPE), powerpc64-linux-gnu)
  TYPE_FLAGS += --with-boinc-platform=ppc64-linux-gnu \
    --with-boinc-alt-platform=powerpc-linux-gnu
endif

# Change BOINC platform sparc-unknown-linux-gnu to sparc-sun-linux-gnu.
ifeq ($(DEB_HOST_GNU_TYPE), sparc-linux-gnu)
  TYPE_FLAGS += --with-boinc-platform=sparc-sun-linux-gnu
endif

# Not touching BOINC platform for hurd for the very moment.
# Manually specify the MAXPATHLEN for GNU where this limit
# is not existing.
ifeq ($(DEB_HOST_GNU_TYPE), i486-gnu)
  # setting it to the regular limit for the other flavours of Debian
  CFLAGS += -DMAXPATHLEN=4096
  #TYPE_FLAGS += --with-boinc-platform=i686-pc-hurd-gnu
endif

ifneq (,$(findstring clang,$(DEB_BUILD_OPTIONS)))
  export CXX=clang
endif

CFLAGS += -Wall
CXXFLAGS += -Wall

ifeq (,$(DEB_OPT_FLAGS))
   DEB_OPT_FLAGS = -O3 -funroll-loops -fforce-addr -ffast-math
   $(info W: No default DEB_OPT_FLAGS set, adding $(DEB_OPT_FLAGS))
endif

CFLAGS += $(DEB_OPT_FLAGS)
CXXFLAGS += $(DEB_OPT_FLAGS)

CFLAGS_boinc-client := $(CFLAGS)
CXXFLAGS_boinc-client := $(CXXFLAGS)

CCorig := $(CC)
CXXorig := $(CXX)

# Link-time optimisation demands knowledge about all CFLAGS both at
# compile time (as represented by CFLAGS and CXXFLAGS) but also at
# at link time.
ifeq (,$(findstring nolto,$(DEB_BUILD_OPTIONS)))
 $(info I: Activating LinkTimeOptimisation)
 CFLAGS += -flto
 CXXFLAGS += -flto
 LDFLAGS += -flto
 CXX := $(CXX) $(CXXFLAGS)
 CC := $(CC) $(CFLAGS)
 AR := gcc-ar
 RANLIB := gcc-ranlib
endif

#copy the original control.in file
$(shell cp debian/control.in debian/control)
$(shell sed '/^#/d' -i debian/control)

export ENABLE_SERVER_TEST := $(shell dpkg-parsechangelog -S Distribution |egrep -v 'experimental|UNRELEASED')

ifeq (,$(ENABLE_SERVER_TEST))
$(shell sed 's/^%//' -i debian/control)
else
$(shell sed '/^%/d' -i debian/control)
endif

ifeq (,$(ENABLE_SERVER_TEST))
$(info I: Building both the server and the client packages)
ENABLE_SERVER := --enable-server
else
$(info I: Building regular client packages only)
#ENABLE_SERVER := --disable-server
endif

#ENABLE_CLIENT_TEST := $(shell egrep '^Package:.*boinc$$' debian/control debian/control.in)
#ifneq (,$(ENABLE_CLIENT_TEST))
ENABLE_CLIENT := --enable-client --enable-manager --enable-dynamic-client-linkage
$(shell sed 's/^@//' -i debian/control)
#else
#ENABLE_CLIENT := --disable-client --disable-manager
#$(shell sed '/^@/d' -i debian/control)
#endif

# --disable-static
# For debugging, these options are useful:
#   --enable-debug
#   --enable-wx-debug (need to install libwxbase3.0-0-dbg and libwxgtk3.0-0-dbg)
#
CFGFLAGS_boinc-client = \
  $(TYPE_FLAGS) \
  --prefix=/usr \
  --bindir=/usr/bin \
  --localstatedir=/var/lib \
  $(ENABLE_CLIENT) \
  $(ENABLE_SERVER) \
  --disable-fcgi \
  --enable-libraries \
  --enable-unicode \
  --enable-shared \
  --enable-static \
  --enable-dynamic-client-linkage \
  --with-ssl \
  --with-x \
  CFLAGS="$(CFLAGS_boinc-client)"

%:
	dh $@ --with python3 --no-parallel

override_dh_autoreconf-indep:

override_dh_clean:
	dh_clean
	rm -rf config.log
	rm -rf clientscr/.libs
	rm -rf debian/boinc-app-examples   debian/boinc-app-examples.substvars
	rm -rf debian/boinc-server-maker   debian/boinc-server-maker.substvars
	rm -rf debian/boinc-cgi-stripchart debian/boinc-cgi-stripchart.substvars
	rm -rf debian/boinc-dbg            debian/boinc-dbg.substvars
	rm -rf debian/boinc-server-dbg     debian/boinc-server-dbg.substvars
	rm -rf debian/*.debhelper
	rm -rf debian/tmp autoreconf-stamp build-*-stamp install-*-stamp
	rm -fr debian/boinc-amd-opencl debian/boinc-screensaver # for cases when this is not in debian/control
	rm -f debian/boinc-screensaver.substvars debian/boinc-amd-opencl.substvars # dito
	rm -f debian/boinc-cgi-stripchart.substvars
	# sudden differences yet remaining to be resolved
	rm -f api/libboinc_graphics2.la
	rm -f test-driver
	rm -f sched/adjust_user_priority sched/size_regulator
	rm -f config.status libtool version.h stamp-h1
	find . -name ".libs" | xargs -r rm -r
	find zip -name "*.lo" -delete
	rm -rf py/lib
	if [ -d .git ]; then \
